<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Email ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Email extends AbstractStructArrayBase
{
    /**
     * The Email
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Email[]
     */
    public $Email;
    /**
     * Constructor method for ArrayOfJPSOAP_Email
     * @uses ArrayOfJPSOAP_Email::setEmail()
     * @param \StructType\JPSOAP_Email[] $email
     */
    public function __construct(array $email = array())
    {
        $this
            ->setEmail($email);
    }
    /**
     * Get Email value
     * @return \StructType\JPSOAP_Email[]|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Email[] $email
     * @return \ArrayType\ArrayOfJPSOAP_Email
     */
    public function setEmail(array $email = array())
    {
        foreach ($email as $arrayOfJPSOAP_EmailEmailItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_EmailEmailItem instanceof \StructType\JPSOAP_Email) {
                throw new \InvalidArgumentException(sprintf('The Email property can only contain items of \StructType\JPSOAP_Email, "%s" given', is_object($arrayOfJPSOAP_EmailEmailItem) ? get_class($arrayOfJPSOAP_EmailEmailItem) : gettype($arrayOfJPSOAP_EmailEmailItem)), __LINE__);
            }
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Add item to Email value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Email $item
     * @return \ArrayType\ArrayOfJPSOAP_Email
     */
    public function addToEmail(\StructType\JPSOAP_Email $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Email) {
            throw new \InvalidArgumentException(sprintf('The Email property can only contain items of \StructType\JPSOAP_Email, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Email[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Email|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Email|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Email|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Email|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Email|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Email
     */
    public function getAttributeName()
    {
        return 'Email';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_Email
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
